#include "functions.h"

extern SPI_HandleTypeDef SpiHandle;


void Init_Led(){
	 /* -1- Enable GPIOE Clock (to be able to program the configuration registers) */
	  __HAL_RCC_GPIOE_CLK_ENABLE();
	  GPIO_InitTypeDef  GPIO_LedStruct;

	  /* -2- Configure PE.8 to PE.15 IOs in output push-pull mode to drive external LEDs */
	  GPIO_LedStruct.Pin = (GPIO_PIN_15 |GPIO_PIN_14 |GPIO_PIN_13 |GPIO_PIN_12 |GPIO_PIN_11 | GPIO_PIN_10 | GPIO_PIN_9 | GPIO_PIN_8);
	  GPIO_LedStruct.Mode = GPIO_MODE_OUTPUT_PP;
	  GPIO_LedStruct.Pull = GPIO_PULLUP;
	  GPIO_LedStruct.Speed = GPIO_SPEED_FREQ_HIGH;

	  HAL_GPIO_Init(GPIOE, &GPIO_LedStruct);

}



void Init_Button(){
	 GPIO_InitTypeDef  GPIO_ButtonStruct;
	 /* -1- Enable GPIOA Clock (to be able to program the configuration registers) */
	  __HAL_RCC_GPIOA_CLK_ENABLE();

	  GPIO_ButtonStruct.Pin = GPIO_PIN_0;
	  GPIO_ButtonStruct.Mode = GPIO_MODE_INPUT;
	  GPIO_ButtonStruct.Pull = GPIO_NOPULL;
	  GPIO_ButtonStruct.Speed = GPIO_SPEED_FREQ_HIGH;

	  HAL_GPIO_Init(GPIOA, &GPIO_ButtonStruct);

}

//Initialize SPI2 interface
void Init_SPI(){

	GPIO_InitTypeDef  GPIO_SPI2Struct;
	/* -1- Enable GPIOB Clock (to be able to program the configuration registers) */
	__HAL_RCC_GPIOB_CLK_ENABLE();

	/* -2- Configure GPIOB for SPI2 on pins 13 (SCLK), 14 (MISO), 15 (MOSI) */
	GPIO_SPI2Struct.Pin =  GPIO_PIN_13 | GPIO_PIN_14 | GPIO_PIN_15;
	GPIO_SPI2Struct.Mode = GPIO_MODE_AF_PP;
	GPIO_SPI2Struct.Pull = GPIO_PULLUP;
	GPIO_SPI2Struct.Speed = GPIO_SPEED_FREQ_HIGH;
	GPIO_SPI2Struct.Alternate = GPIO_AF5_SPI2;

	HAL_GPIO_Init(GPIOB, &GPIO_SPI2Struct);





	__HAL_RCC_SPI2_CLK_ENABLE();

	SpiHandle.Instance               = SPI2;

	SpiHandle.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_256;
	SpiHandle.Init.Direction         = SPI_DIRECTION_2LINES;
	SpiHandle.Init.CLKPhase          = SPI_PHASE_1EDGE;
	SpiHandle.Init.CLKPolarity       = SPI_POLARITY_HIGH;
	SpiHandle.Init.CRCCalculation    = SPI_CRCCALCULATION_DISABLED;
	SpiHandle.Init.CRCPolynomial     = 7;
	SpiHandle.Init.DataSize          = SPI_DATASIZE_8BIT;
	SpiHandle.Init.FirstBit          = SPI_FIRSTBIT_MSB;
	SpiHandle.Init.NSS               = SPI_NSS_SOFT;
	SpiHandle.Init.TIMode            = SPI_TIMODE_DISABLED;

	#ifdef MASTER_BOARD
	SpiHandle.Init.Mode = SPI_MODE_MASTER;
	#else
	SpiHandle.Init.Mode = SPI_MODE_SLAVE;
	#endif /* MASTER_BOARD */

	HAL_SPI_Init(&SpiHandle);
}


